# coding: utf-8

"""
    Mantium API

    Mantium API Documentation  # noqa: E501

    The version of the OpenAPI document: 1.0.1108
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from mantium_spec.configuration import Configuration


class MantiumRetrieverTool(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'description': 'str',
        'supporting_docs_top_k': 'int'
    }

    attribute_map = {
        'description': 'description',
        'supporting_docs_top_k': 'supporting_docs_top_k'
    }

    def __init__(self, description='Useful for when you need to answer questions about the underlying data in a Mantium application.', supporting_docs_top_k=2, local_vars_configuration=None):  # noqa: E501
        """MantiumRetrieverTool - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._description = None
        self._supporting_docs_top_k = None
        self.discriminator = None

        if description is not None:
            self.description = description
        if supporting_docs_top_k is not None:
            self.supporting_docs_top_k = supporting_docs_top_k

    @property
    def description(self):
        """Gets the description of this MantiumRetrieverTool.  # noqa: E501

        Description of the tool.  # noqa: E501

        :return: The description of this MantiumRetrieverTool.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this MantiumRetrieverTool.

        Description of the tool.  # noqa: E501

        :param description: The description of this MantiumRetrieverTool.  # noqa: E501
        :type description: str
        """

        self._description = description

    @property
    def supporting_docs_top_k(self):
        """Gets the supporting_docs_top_k of this MantiumRetrieverTool.  # noqa: E501

        The number of supporting documents the chat agent can use to generate an answer.  # noqa: E501

        :return: The supporting_docs_top_k of this MantiumRetrieverTool.  # noqa: E501
        :rtype: int
        """
        return self._supporting_docs_top_k

    @supporting_docs_top_k.setter
    def supporting_docs_top_k(self, supporting_docs_top_k):
        """Sets the supporting_docs_top_k of this MantiumRetrieverTool.

        The number of supporting documents the chat agent can use to generate an answer.  # noqa: E501

        :param supporting_docs_top_k: The supporting_docs_top_k of this MantiumRetrieverTool.  # noqa: E501
        :type supporting_docs_top_k: int
        """
        if (self.local_vars_configuration.client_side_validation and
                supporting_docs_top_k is not None and supporting_docs_top_k > 3):  # noqa: E501
            raise ValueError("Invalid value for `supporting_docs_top_k`, must be a value less than or equal to `3`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                supporting_docs_top_k is not None and supporting_docs_top_k < 1):  # noqa: E501
            raise ValueError("Invalid value for `supporting_docs_top_k`, must be a value greater than or equal to `1`")  # noqa: E501

        self._supporting_docs_top_k = supporting_docs_top_k

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MantiumRetrieverTool):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, MantiumRetrieverTool):
            return True

        return self.to_dict() != other.to_dict()
